Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | List of all members
Botan::PKCS7_Padding Class Referencefinal

`#include <mode_pad.h>`

Inheritance diagram for Botan::PKCS7_Padding:

## Public Member Functions
void | add_padding (secure_vector< uint8_t > &buffer, size_t final_block_bytes, size_t block_size) const override
std::string | name () const override
size_t | unpad (const uint8_t[], size_t) const override
bool | valid_blocksize (size_t bs) const override

## Detailed Description

PKCS#7 Padding

Definition at line 69 of file mode_pad.h.

## Member Function Documentation

## ◆ add_padding()

void Botan::PKCS7_Padding::add_padding | ( | secure_vector< uint8_t > & | buffer,
|  | size_t | final_block_bytes,
|  | size_t | block_size
| ) |  | const
| override virtual

Add padding bytes to buffer.

Parameters

  buffer | data to pad
  final_block_bytes | size of the final block in bytes
  block_size | size of each block in bytes

Implements Botan::BlockCipherModePaddingMethod.

Definition at line 41 of file mode_pad.cpp.

44 {
45 /*
46 Padding format is
47 01
48 0202
49 030303
50 ...
51 */
52 BOTAN_DEBUG_ASSERT(last_byte_pos < BS);
53
54 const uint8_t padding_len = static_cast<uint8_t>(BS - last_byte_pos);
55
56 buffer.resize(buffer.size() + padding_len);
57
58 CT::poison(&last_byte_pos, 1);
59 CT::poison(buffer.data(), buffer.size());
60
61 BOTAN_DEBUG_ASSERT(buffer.size() % BS == 0);
62 BOTAN_DEBUG_ASSERT(buffer.size() >= BS);
63
64 const size_t start_of_last_block = buffer.size() - BS;
65 const size_t end_of_last_block = buffer.size();
66 const size_t start_of_padding = buffer.size() - padding_len;
67
68 for(size_t i = start_of_last_block; i != end_of_last_block; ++i)
69 {
70 auto needs_padding = CT::Mask<uint8_t>(CT::Mask<size_t>::is_gte(i, start_of_padding));
71 buffer[i] = needs_padding.select(padding_len, buffer[i]);
72 }
73
74 CT::unpoison(buffer.data(), buffer.size());
75 CT::unpoison(last_byte_pos);
76 }
BOTAN_DEBUG_ASSERT
#define BOTAN_DEBUG_ASSERT(expr)
Definition: assert.h:123
Botan::CT::Mask::is_gte
static Mask< T > is_gte(T x, T y)
Definition: ct_utils.h:181
Botan::CT::poison
void poison(const T *p, size_t n)
Definition: ct_utils.h:48
Botan::CT::unpoison
void unpoison(const T *p, size_t n)
Definition: ct_utils.h:59

References BOTAN_DEBUG_ASSERT, Botan::CT::poison(), and Botan::CT::unpoison().

## ◆ name()

std::string Botan::PKCS7_Padding::name | ( |  | ) | const
| inline override virtual

Returns
  name of the mode

Implements Botan::BlockCipherModePaddingMethod.

Definition at line 80 of file mode_pad.h.

80{ return "PKCS7"; }

## ◆ unpad()

size_t Botan::PKCS7_Padding::unpad | ( | const uint8_t | block[],
|  | size_t | len
| ) |  | const
| override virtual

Remove padding bytes from block

Parameters

  block | the last block
  len | the size of the block in bytes

Returns
  number of data bytes, or if the padding is invalid returns len

Implements Botan::BlockCipherModePaddingMethod.

Definition at line 81 of file mode_pad.cpp.

82 {
83 if(!valid_blocksize(input_length))
84 return input_length;
85
86 CT::poison(input, input_length);
87
88 const uint8_t last_byte = input[input_length-1];
89
90 /*
91 The input should == the block size so if the last byte exceeds
92 that then the padding is certainly invalid
93 */
94 auto bad_input = CT::Mask<size_t>::is_gt(last_byte, input_length);
95
96 const size_t pad_pos = input_length - last_byte;
97
98 for(size_t i = 0; i != input_length - 1; ++i)
99 {
100 // Does this byte equal the expected pad byte?
101 const auto pad_eq = CT::Mask<size_t>::is_equal(input[i], last_byte);
102
103 // Ignore values that are not part of the padding
104 const auto in_range = CT::Mask<size_t>::is_gte(i, pad_pos);
105 bad_input |= in_range & (~pad_eq);
106 }
107
108 CT::unpoison(input, input_length);
109
110 return bad_input.select_and_unpoison(input_length, pad_pos);
111 }
Botan::CT::Mask::is_gt
static Mask< T > is_gt(T x, T y)
Definition: ct_utils.h:165
Botan::CT::Mask::is_equal
static Mask< T > is_equal(T x, T y)
Definition: ct_utils.h:149
Botan::PKCS7_Padding::valid_blocksize
bool valid_blocksize(size_t bs) const override
Definition: mode_pad.h:78

References Botan::CT::Mask< T >::is_equal(), Botan::CT::Mask< T >::is_gt(), Botan::CT::Mask< T >::is_gte(), Botan::CT::poison(), Botan::CT::unpoison(), and valid_blocksize().

## ◆ valid_blocksize()

bool Botan::PKCS7_Padding::valid_blocksize | ( | size_t | block_size | ) | const
| inline override virtual

Parameters

  block_size | of the cipher

Returns
  valid block size for this padding mode

Implements Botan::BlockCipherModePaddingMethod.

Definition at line 78 of file mode_pad.h.

78{ return (bs > 2 && bs < 256); }

Referenced by unpad().

The documentation for this class was generated from the following files:

- src/lib/modes/mode_pad/mode_pad.h
- src/lib/modes/mode_pad/mode_pad.cpp